/*
  This file is under public domain.
*/

/*
  Tiny ANSI to UTF16 converter
  using WideCharToMultiByte Windows API.
 */

#include <windows.h>
#include <stdlib.h>

#include "miniWString.h"

miniWString::miniWString(const char* c) : m_string(0) {
	static const UINT cp = CP_ACP;
	static const DWORD flags = MB_PRECOMPOSED;
	
	if (c) {
		int length = MultiByteToWideChar(cp, flags, c, -1, NULL, 0);
		if (length > 0) {
			m_string = (LPWSTR) malloc(length * sizeof(WCHAR));
			if (m_string) {
				m_string[0] = '\0';
				MultiByteToWideChar(cp, flags, c, -1, m_string, length);
			}
		}
	}
}
